
local addonName, addonData = ...

-- Options - change as required 
-- Display Character Name 
addonData.showToonName = true
-- Display Realm Name if we are also showing Character Name
addonData.showRealmName = addonData.showToonName and true
-- Display Battle Tag instead of Real Name
addonData.showBattleTag = true

-- Our Event Frame
addonData.XRICEvents = CreateFrame("Frame")
addonData.XRICEvents:RegisterEvent("ADDON_LOADED")
addonData.XRICEvents:SetScript("OnEvent",function(self,event,...)

	-- Initialise Our Stuff, fill the class name list and set up the chatframes to use our own addmessage function
	if event == "ADDON_LOADED" and ... == addonName then
		addonData:GenerateClassNameList()

		for i = 1, NUM_CHAT_WINDOWS do
			if i ~= 2 then
				local chatFrame = _G["ChatFrame" .. i]
				addonData:CustomizeChatFrame(chatFrame)
			end
		end

		if ( not addonData.FCF_OpenTemporaryWindow ) then
			addonData.FCF_OpenTemporaryWindow = FCF_OpenTemporaryWindow
			FCF_OpenTemporaryWindow = function(...)
				local chatFrame = addonData.FCF_OpenTemporaryWindow(...)
				addonData:CustomizeChatFrame(chatFrame)
				return chatFrame
			end
		end
		if addonData.iiLinksLoaded then
			self:UnregisterEvent("ADDON_LOADED")
		end

		-- Register the events we want to monitor
		self:RegisterEvent("PLAYER_ENTERING_WORLD")		
		self:RegisterEvent("BN_CONNECTED")				
		self:RegisterEvent("BN_FRIEND_ACCOUNT_ONLINE")	
		self:RegisterEvent("BN_FRIEND_TOON_ONLINE")
		self:RegisterEvent("CHAT_MSG_BN_INLINE_TOAST_ALERT")
		self:RegisterEvent("CHAT_MSG_BN_WHISPER_PLAYER_OFFLINE")
		addonData.XRICLoaded = true

	-- Monitor iiLinks addon being loaded
	elseif event == "ADDON_LOADED" and ... == "iiLinks" then
		addonData.iiLinksLoaded = true
		if ( addonData.XRICLoaded ) then
			self:UnregisterEvent("ADDON_LOADED")
		end

	-- When player connects to battle net .. in case it disconnects you 
	elseif event == "BN_CONNECTED" then
		addonData:BuildPresenceTable()

	--	When player first logs in
	elseif event == "PLAYER_ENTERING_WORLD" then
		addonData:BuildPresenceTable()
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")

	-- When a friends account logs in ( not necessarily wow )
	elseif event == "BN_FRIEND_ACCOUNT_ONLINE" then
		addonData:BuildPresenceTable()

	-- When a friends toon logs into wow
	elseif event == "BN_FRIEND_TOON_ONLINE" then
		addonData:BuildPresenceTable()

	elseif event == "CHAT_MSG_BN_INLINE_TOAST_ALERT" then
		addonData:BuildPresenceTable()

	elseif event == "CHAT_MSG_BN_WHISPER_PLAYER_OFFLINE" then
		addonData:BuildPresenceTable()

	end	

end)
